from django.db import connection
from ESP.utils import log
from ESP.settings import DATABASES

#temporary table syntax (TT)
if DATABASES['default']['ENGINE'] == 'sql_server.pyodbc': # ms-sql server
    TT_SYNTX="#"
    TT_PRFX="#"
else: # postgres
    TT_SYNTX="temporary "
    TT_PRFX=""

      

def generate_diagnosed_hypertension_cases():
    with connection.cursor() as cursor:
        #identify inpatient days -- per mapped inpatient encounters in rs_conf_mapping
        cursor.execute("select patient_id, date into " + TT_SYNTX + "temp_inpat_encs from emr_encounter e join gen_pop_tools.rs_conf_mapping cm on cm.src_value=e.raw_encounter_type and cm.src_field='raw_encounter_type' and cm.mapped_value='inpatient' group by patient_id, date")
        #hypertension dx events -- rs_conf_mapping non-inpat only
        cursor.execute("Select id as event_id, object_id, patient_id, date into " + TT_SYNTX + "temp_dx_hypert from hef_event e where not exists (select null from " + TT_PRFX + "temp_inpat_encs ie where ie.patient_id=e.patient_id and ie.date=e.date) and e.name = 'dx:hypertension'")
        if DATABASES['default']['ENGINE'] == 'sql_server.pyodbc': # ms-sql server
            cursor.execute("with temp_dx_hypert_rownum as (select t0.*, row_number() over (partition by patient_id order by patient_id, date, object_id) as rownum from " + TT_PRFX + "temp_dx_hypert) Select patient_id, date, object_id into " + TT_SYNTX + "temp_first_dx_hypert from " + TT_PRFX + "temp_dx_hypert_rownum where rownum=1")        
        else: # postgres
            #first dx -- not SQL serrver compliant (distinct on won't work)
            cursor.execute("Select distinct on (patient_id) patient_id, date, object_id into " + TT_SYNTX + "temp_first_dx_hypert from " + TT_PRFX + "temp_dx_hypert order by patient_id, date, object_id")
        #anti-hypertensive rx events -- rs_conf_mapping non-inpat only
        cursor.execute("select patient_id, date, id as event_id into " + TT_SYNTX + "tmp_antihypert_presc from hef_event e where name in ('rx:hydrochlorothiazide','rx:chlorthalidone','rx:indapamide','rx:amlodipine','rx:clevidipine','rx:felodipine','rx:isradipine','rx:nicardipine','rx:nicardipine','rx:nifedipine','rx:nisoldipine','rx:diltiazem','rx:verapamil','rx:atenolol','rx:betaxolol','rx:bisoprolol','rx:carvedilol','rx:labetolol','rx:metoprolol','rx:nadolol','rx:nebivolol','rx:pindolol','rx:propranolol','rx:benazepril','rx:catopril','rx:enalapril','rx:fosinopril','rx:lisinopril','rx:moexipril','rx:perindopril','rx:quinapril','rx:ramipril','rx:trandolapril','rx:candesartan','rx:eprosartan','rx:irbesartan','rx:losartan','rx:olmesartan','rx:telmisartan','rx:valsartan','rx:clonidine','rx:doxazosin','rx:guanfacine','rx:methyldopa','rx:prazosin','rx:erazosin','rx:eplerenone','rx:sprinolactone','rx:aliskiren','rx:hydralazine') and not exists (select null from " + TT_PRFX + "temp_inpat_encs ie where ie.patient_id=e.patient_id and ie.date=e.date)")
        cursor.execute("create index " + TT_PRFX + "tmp_antihypert_presc_patid_date_idx on tmp_antihypert_presc (patient_id, date)")
        #pregnancies
        cursor.execute("Select patient_id, date, id as event_id into " + TT_SYNTX + "tmp_preg from hef_event where name='dx:pregnancy'")
        cursor.execute("select patient_id, min(date) as start_date, max(date) + interval '1 year' as end_date into " + TT_SYNTX + "tmp_preg_seqs from (select patient_id, date, i, dt_i, sum(case when dt_i + interval '1 year' >= date then 0 else 1 end) over (partition by patient_id order by i) grp from (select patient_id, date, row_number() over (partition by patient_id order by date) i, lag(date) over (partition by patient_id order by date) dt_i from " + TT_PRFX + "tmp_preg group by patient_id, date) t00) t0 group by patient_id, grp order by patient_id, start_date")
        #end stage renal events
        cursor.execute("select e0.patient_id, e0.date, min(e0.id) as event_id into " + TT_SYNTX + "tmp_esr_diag from hef_event e0 join (Select patient_id, min(date) as date from hef_event where name='dx:endstagerenal' group by patient_id) e1 on e1.date=e0.date and e1.patient_id=e0.patient_id group by e0.patient_id, e0.date")
        #18th bday
        cursor.execute("select id as patient_id, (date_of_birth + interval '18 years')::date bd18 into " + TT_SYNTX + "tmp_18th_bday from emr_patient where date_of_birth is not null")
        #86th bday (need through age 85)
        cursor.execute("select id as patient_id, (date_of_birth + interval '86 years')::date bd86 into " + TT_SYNTX + "tmp_86th_bday from emr_patient where date_of_birth is not null")
        #get earlier of ESR or age currently over 85 
        cursor.execute("select case when t1.patient_id is null then t2.patient_id else t1.patient_id end as patient_id, case when t1.date is null or t1.date < t2.bd86 then t2.bd86 else t1.date end as d_date into " + TT_SYNTX + "tmp_deact_dt from " + TT_PRFX + "tmp_esr_diag t1 full outer join (select * from " + TT_PRFX + "tmp_86th_bday where bd86<current_date) t2 on t1.patient_id=t2.patient_id group by case when t1.patient_id is null then t2.patient_id else t1.patient_id end, case when t1.date is null or t1.date < t2.bd86 then t2.bd86 else t1.date end")
        #hypertension cases 
        cursor.execute("select hd.patient_id, min(hd.date) as case_date, min(t2.d_date) as inactive_date into " + TT_SYNTX + "tmp_cases from " + TT_PRFX + "temp_dx_hypert hd join " + TT_PRFX + "tmp_18th_bday t0 on t0.patient_id=hd.patient_id and t0.bd18<=hd.date join " + TT_PRFX + "tmp_86th_bday t1 on t1.patient_id=hd.patient_id and t1.bd86>hd.date left join " + TT_PRFX + "tmp_deact_dt t2 on t2.patient_id=hd.patient_id and t2.d_date > hd.date where not exists (select null from " + TT_PRFX + "tmp_esr_diag t2 where t2.patient_id=hd.patient_id and t2.date<=hd.date) and not exists (select null from " + TT_PRFX + "tmp_preg t3 where t3.patient_id=hd.patient_id and hd.date between t3.date and t3.date + interval '1 year') group by hd.patient_id")
        #drop cases with new start_date
        cursor.execute("select c.id as case_id into " + TT_SYNTX + "tmp_drop_cases from nodis_case c where condition='diagnosedhypertension' and exists (select null from " + TT_PRFX + "tmp_cases tc where tc.patient_id=c.patient_id and c.date<>tc.case_date)")
        cursor.execute("delete from nodis_caseactivehistory cah where exists (select null from " + TT_PRFX + "tmp_drop_cases dc where dc.case_id=cah.case_id)")
        cursor.execute("delete from nodis_case_events ce where exists (select null from " + TT_PRFX + "tmp_drop_cases dc where dc.case_id=ce.case_id)")
        cursor.execute("delete from nodis_case c where exists (select null from " + TT_PRFX + "tmp_drop_cases dc where dc.case_id=c.id)")
        #add new cases
        cursor.execute("insert into nodis_case (patient_id, condition, date, criteria, source, status, notes, reportables, created_timestamp, updated_timestamp, sent_timestamp, followup_sent, provider_id, inactive_date, isactive) select patient_id, 'diagnosedhypertension' as condition, case_date as date, 'Dx hypertension' as criteria, 'urn:x-esphealth:disease:commoninf:diagnosedhypertension:sql' as source, 'AR' as status, null::text as notes, null::text as reportables, current_timestamp as created_timestamp, current_timestamp as updated_timestamp, null::timestamp as sent_timestamp, FALSE as followup_sent, 1 as provider_id, inactive_date, case when inactive_date is null then TRUE else FALSE end as isactive from " + TT_PRFX + "tmp_cases tc where not exists (select null from nodis_case c where condition='diagnosedhypertension' and c.patient_id=tc.patient_id and c.date=tc.case_date)")
        counts = cursor.rowcount
        cursor.execute("select patient_id, id as case_id into " + TT_SYNTX + "tmp_case_ids from nodis_case where condition='diagnosedhypertension'")
        #Here are highbp events.
        cursor.execute("select patient_id, date, id as event_id into " + TT_SYNTX + "tmp_highbp from hef_event e where name='enc:highbp' and not exists (select null from " + TT_PRFX + "temp_inpat_encs ie where ie.patient_id=e.patient_id and ie.date=e.date)")
        #Here are not-highbp events.
        cursor.execute("select patient_id, date, id as event_id into " + TT_SYNTX + "tmp_not_highbp from hef_event e where name in ('enc:not_highbp_c','enc:not_highbp_w') and not exists (select null from " + TT_PRFX + "temp_inpat_encs ie where ie.patient_id=e.patient_id and ie.date=e.date)")
        #here are all the events to use in building the caseactivehistory (some of these are not hef events, such as birthdays)
        cursor.execute("select patient_id, case_date, hdate, event_id, content_type_id, etype into " + TT_SYNTX + "tmp_events from (Select distinct c.patient_id, c.case_date, d.date as hdate, d.event_id, ct.id as content_type_id, 'hdx' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "temp_dx_hypert d on c.patient_id=d.patient_id and d.date between c.case_date and coalesce(c.inactive_date, current_date) join django_content_type ct on app_label='hef' and model='event' union Select distinct c.patient_id, c.case_date, hbp.date as hdate, hbp.event_id, ct.id as content_type_id, 'hbp' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_highbp hbp on c.patient_id=hbp.patient_id and hbp.date between c.case_date and coalesce(c.inactive_date, current_date) join django_content_type ct on app_label='hef' and model='event' union Select distinct c.patient_id, c.case_date, nhbp.date as hdate, nhbp.event_id, ct.id as content_type_id, 'cbp' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_not_highbp nhbp on c.patient_id=nhbp.patient_id and nhbp.date between c.case_date and coalesce(c.inactive_date, current_date) join django_content_type ct on app_label='hef' and model='event' union Select distinct c.patient_id, c.case_date, bd86.bd86 as hdate, bd86.patient_id as event_id, ct.id as content_type_id, 'b86' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_86th_bday bd86 on c.patient_id=bd86.patient_id and bd86.bd86=c.inactive_date join django_content_type ct on app_label='emr' and model='patient' union Select distinct c.patient_id, c.case_date, esr.date as hdate, esr.event_id, ct.id as content_type_id, 'esr' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_esr_diag esr on c.patient_id=esr.patient_id and esr.date=c.inactive_date join django_content_type ct on app_label='hef' and model='event' union Select distinct c.patient_id, c.case_date, prg.date as hdate, prg.event_id, ct.id as content_type_id, 'prg' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_preg prg on c.patient_id=prg.patient_id and prg.date between c.case_date and coalesce(c.inactive_date, current_date) join django_content_type ct on app_label='hef' and model='event' union select distinct c.patient_id, c.case_date, rx.date as hdate, rx.event_id, ct.id as content_type_id, 'rxs' etype from " + TT_PRFX + "tmp_cases c join " + TT_PRFX + "tmp_antihypert_presc rx on c.patient_id=rx.patient_id and rx.date between c.case_date and coalesce(c.inactive_date, current_date) join django_content_type ct on app_label='hef' and model='event' ) t0")
        cursor.execute("create index tmp_event_etypes on tmp_events (etype)")
        cursor.execute("analyse tmp_events")
        cursor.execute("insert into nodis_case_events (case_id, event_id) select t0.case_id, t1.event_id from " + TT_PRFX + "tmp_case_ids t0 join " + TT_PRFX + "tmp_events t1 on t1.patient_id=t0.patient_id where t1.etype<>'b86' and not exists (select null from nodis_case_events t00 where t00.case_id=t0.case_id and t00.event_id=t1.event_id) group by t0.case_id, t1.event_id")
        #get relevant clinical encounters
        cursor.execute("select patient_id, date into " + TT_SYNTX + "tmp_clin_enc from gen_pop_tools.clin_enc ce where exists (select null from " + TT_PRFX + "tmp_case_ids ci where ci.patient_id=ce.patient_id) and not exists (select null from " + TT_PRFX + "temp_inpat_encs ie where ie.patient_id=ce.patient_id and ie.date=ce.date) group by patient_id, date")
        cursor.execute("CREATE INDEX tmp_clin_enc_pat_date_idx ON tmp_clin_enc USING btree (patient_id, date)")
        cursor.execute("Analyze tmp_clin_enc")
        #identify the reverters
        cursor.execute("select patient_id, rdate, next_date, max(cbp_date) as cbp_date into " + TT_SYNTX + "tmp_reverters from ( select * from (select t0.patient_id, Case when t0.date + interval '2 years' >= coalesce(max(t1.date)+interval '2 years',t0.date+interval '2 years') then t0.date+ interval '2 years' else max(t1.date)+ interval '2 years' end as rdate, cbp.date cbp_date, t0.next_date from (select patient_id, date, coalesce(lead(date) over (partition by patient_id order by date), current_date) as next_date from " + TT_PRFX + "temp_dx_hypert) t0 left join " + TT_PRFX + "tmp_antihypert_presc t1 on t1.patient_id=t0.patient_id and t1.date between t0.date and t0.next_date join " + TT_PRFX + "tmp_not_highbp cbp on cbp.patient_id= t0.patient_id and cbp.date < t0.next_date where date_part('year', age(t0.next_date,t0.date)) > 2 and exists (select count(*) from " + TT_PRFX + "tmp_clin_enc ce where t0.patient_id=ce.patient_id and ce.date between t0.date and t0.next_date having count(*) >= 2) group by t0.patient_id, t0.date, cbp.date, t0.next_date ) t00 where not exists (select null from " + TT_PRFX + "tmp_highbp hbp where hbp.patient_id=t00.patient_id and hbp.date between t00.cbp_date and t00.next_date) and rdate < next_date and cbp_date<rdate) t000 group by patient_id, rdate, next_date")
        #get BP events
        cursor.execute("select patient_id, hdate, event_id, content_type_id, etype::varchar(3) etype into " + TT_SYNTX + "tmp_bp_evnts from " + TT_PRFX + "tmp_events where etype in ('hbp','cbp')")
        cursor.execute("select patient_id, hdate, event_id, content_type_id, etype::varchar(3) etype into " + TT_SYNTX + "tmp_bp_exlu_evnts from " + TT_PRFX + "tmp_bp_evnts  t0 where not exists (select null from " + TT_PRFX + "tmp_preg_seqs t1 where t0.hdate between t1.start_date and t1.end_date and t1.patient_id=t0.patient_id) and not exists (select null from " + TT_PRFX + "tmp_reverters rvrt where rvrt.patient_id=t0.patient_id and t0.hdate >= rvrt.rdate and t0.hdate < rvrt.next_date)")
        cursor.execute("select patient_id, hdate, event_id, content_type_id, etype::varchar(3) etype into " + TT_SYNTX + "tmp_dstat_evnts from " + TT_PRFX + "tmp_events t0 where etype in ('prg','esr','b86')")
        cursor.execute("select patient_id, case_date, hdate, event_id, content_type_id, etype::varchar(3) etype into " + TT_SYNTX + "tmp_dxonly_evnts from " + TT_PRFX + "tmp_events where etype='hdx'")
        cursor.execute("select t0.patient_id, t0.hdate, t0.event_id, t0.content_type_id, t0.etype::varchar(3) etype into " + TT_SYNTX + "tmp_dx_rvrt from " + TT_PRFX + "tmp_dxonly_evnts t0 join " + TT_PRFX + "tmp_reverters rvrt on  rvrt.patient_id=t0.patient_id and t0.hdate=rvrt.next_date")
        cursor.execute("select t0.patient_id, t0.hdate, t0.event_id, t0.content_type_id, t0.etype::varchar(3) etype into " + TT_SYNTX + "tmp_dx_events1 from " + TT_PRFX + "tmp_dx_rvrt t0 where exists (select null from " + TT_PRFX + "tmp_reverters rvrt where rvrt.patient_id=t0.patient_id and t0.hdate=rvrt.next_date and not exists (select null from " + TT_PRFX + "tmp_bp_evnts t1 where t1.patient_id=rvrt.patient_id and  t1.hdate=rvrt.next_date ))")
        cursor.execute("select t0.patient_id, t0.hdate, t0.event_id, t0.content_type_id, t0.etype::varchar(3) etype into " + TT_SYNTX + "tmp_dx_events2 from " + TT_PRFX + "tmp_dxonly_evnts t0 where t0.hdate=t0.case_date and not exists (select null from " + TT_PRFX + "tmp_bp_evnts t1 where t1.patient_id=t0.patient_id and t1.hdate=t0.hdate)")
        if DATABASES['default']['ENGINE'] == 'sql_server.pyodbc': # ms-sql server
            cursor.execute("with t000_0 as (select *, row_number() over (partition by patient_id order by patient_id, hdate, etype, event_id) as rownum from (select * from #tmp_bp_exlu_evnts union select * from #tmp_dstat_evnts union select * from #tmp_dx_events1 union select * from #tmp_dx_events2) t0) select * into #t00 from #t000_0 where rownum=1")
            cursor.execute("with t00_0 as (select *, row_number() over (partition by patient_id order by patient_id, hdate, case when etype in ('esr', 'b86') then 0 when etype='prg' then 1 else 2 end) as rownum from #t00) select * into #tmp_pre_pre_hist from #t00_0 where rownum=1 ")
        else:
            cursor.execute("select distinct on (patient_id, hdate) * into temporary tmp_pre_pre_hist from (select distinct on (patient_id, hdate, etype) * from (select * from tmp_bp_exlu_evnts union select * from tmp_dstat_evnts union select * from tmp_dx_events1 union select * from tmp_dx_events2) t0 order by patient_id, hdate, etype, event_id) t00 order by patient_id, hdate, case when etype in ('esr', 'b86') then 0 when etype='prg' then 1 else 2 end")
        cursor.execute("select *, case when (etype <> coalesce(prior_type,'start') and etype <> coalesce(next_type,'end')) then 'both' when etype <> coalesce(prior_type,'start') then 'start' when etype <> coalesce(next_type,'end') then 'end' end as place, case when (etype <> coalesce(prior_type,'start')) then 1 else 0 end as starts, lag(hdate) over (partition by patient_id order by hdate) as prior_date into " + TT_SYNTX + "tmp_prelim_hist from (select *, lag(etype) over (partition by patient_id order by hdate) as prior_type, lead(etype) over (partition by patient_id order by hdate) as next_type from " + TT_PRFX + "tmp_pre_pre_hist ) t00 order by patient_id, hdate")
        cursor.execute("select *, sum(starts) over (partition by patient_id order by hdate) as sgroup into " + TT_SYNTX + "tmp_prelim_hist2 from " + TT_PRFX + "tmp_prelim_hist")
        cursor.execute("select patient_id, hdate, latest_event_date, event_id, content_type_id, etype into " + TT_SYNTX + "tmp_intermed_hist from (select patient_id, hdate, hdate as latest_event_date, event_id, content_type_id, etype, min(case when etype in ('esr','b86') then hdate end) over (partition by patient_id) as min_esrb86 from " + TT_PRFX + "tmp_prelim_hist2 where place='both' union select t0.patient_id, t0.hdate, t1.hdate as latest_event_date, t1.event_id, t1.content_type_id, t1.etype, min(case when t0.etype in ('esr','b86') then t0.hdate end) over (partition by t0.patient_id) as min_esrb86 from " + TT_PRFX + "tmp_prelim_hist2 t0 join " + TT_PRFX + "tmp_prelim_hist2 t1 on t0.patient_id=t1.patient_id and t0.sgroup=t1.sgroup and t0.place='start' and t1.place='end') t00 where min_esrb86 is null or hdate<min_esrb86")
        cursor.execute("select patient_id, latest_event_date+interval '2 years' as hdate, latest_event_date+interval '2 years' as latest_event_date, null::int as event_id, null::int as content_type_id, 'unk'::varchar(3) as etype into " + TT_SYNTX + "tmp_unk from (select patient_id, hdate, latest_event_date, lead(hdate) over (partition by patient_id order by hdate) as next_date from " + TT_PRFX + "tmp_intermed_hist where etype in ('hbp','cbp')) t0 where latest_event_date+interval '2 years' <next_date and not exists (select null from " + TT_PRFX + "tmp_reverters t1 where t1.patient_id=t0.patient_id and  t0.latest_event_date+interval '2 years' between t1.rdate and t1.next_date)")
        cursor.execute("select patient_id, hdate, latest_event_date, event_id, content_type_id, etype into " + TT_SYNTX + "tmp_history from (Select * from " + TT_PRFX + "tmp_intermed_hist union select * from " + TT_PRFX + "tmp_unk union select * from (select t0.patient_id, t1.rdate as hdate, t1.rdate as latest_event_date, null::int as event_id, null::int as content_type_id, 'rvt'::varchar(3) as etype from " + TT_PRFX + "tmp_reverters t1 join " + TT_PRFX + "tmp_cases t0 on t1.patient_id=t0.patient_id) t0) t00")
        cursor.execute("delete from nodis_caseactivehistory cah where exists (select null from nodis_case c where c.id=cah.case_id and c.condition='diagnosedhypertension')")
        ##need to figure out here how to update existing histories.  This currently assumes there are no histories and is rebuilding
        cursor.execute("select case when t0.etype in ('unk','hdx') then 'UK' when t0.etype='hbp' then 'U' when t0.etype='cbp' then 'C' when t0.etype in ('esr','rvt','prg','b86') then 'D' end status, t0.hdate as date, case when t0.etype in ('unk','hdx','hbp','cbp') then 'Q' when t0.etype in ('esr','rvt','prg','b86') then 'D' end change_reason, t0.latest_event_date, t0.event_id as object_id, t1.case_id, t0.content_type_id into " + TT_SYNTX + "tmp_to_insert from " + TT_PRFX + "tmp_history t0 join " + TT_PRFX + "tmp_case_ids t1 on t1.patient_id=t0.patient_id")
        cursor.execute("insert into nodis_caseactivehistory (status, date, change_reason, latest_event_date, object_id, case_id, content_type_id) select distinct on (case_id, date) status, date, change_reason, latest_event_date, object_id, case_id, content_type_id from " + TT_PRFX + "tmp_to_insert order by case_id, date, latest_event_date desc")
        cursor.execute("update nodis_case set isactive=FALSE, inactive_date=t000.date from (select t0.case_id, t0.date from nodis_caseactivehistory t0 join (select t00.case_id, max(t00.date) as maxdate from nodis_caseactivehistory t00 join " + TT_PRFX + "tmp_case_ids t01 on t00.case_id=t01.case_id group by t00.case_id) t1 on t1.case_id=t0.case_id and t0.status='D' and t0.date=t1.maxdate join nodis_case t2 on t0.case_id=t2.id and t2.condition='diagnosedhypertension') t000 where nodis_case.id=t000.case_id")

        #will eventually need this code for SQL server version of ESP
        #if DATABASES['default']['ENGINE'] == 'sql_server.pyodbc': # ms-sql server
        #else: # postgres
        
        return counts
